program cnv_v2;

uses
  SysUtils;

const
  funcname = 'cnv';
  paramnum = 10;
  version  = '1 (memory access violation at border pixels), Delphi compilation';
  author   = 'Adobe';

const
  linewidth = 20;

{$APPTYPE CONSOLE}
{$OPTIMIZATION OFF}

var
  i: PByte;
  j: pointer;
  k, z: smallint;
  s: string;

begin
  asm
    jmp @@__print
    db '<<MARKER>>';
    @@__marker__begin:

(*

Delphi 6 	Adobe 1994	Asm
(mem,reg)	(reg,mem)
-------------------------------------------------
01 F0		03 C6		add eax,esi
01 DA		03 D3		add edx,ebx
01 C1		03 C8		add ecx,eax
09 C0		0B C0           or eax,eax
29 C0		2B C0		sub eax,eax
89 CA		8B D1		mov edx,ecx

*)

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

mov eax,[esp] {param_d}				// result = param_d;
or eax,eax
jz @div_zero				        // if (param_d == 0) goto @div_zero; // return 0
mov ecx,[edi+$000045a8] {CANVAS_OFFSET}		// ecx = CANVAS_OFFSET;
mov eax,[edi+$58] {z}
sub eax,[edi+$5c] {zmin}
add ecx,eax					// ecx += z-zmin;
mov eax,[edi+$4c] {y}
dec eax
sub eax,[edi+$50] {ymin}
mul dword ptr [edi+$000045a0] {ROW_SIZE}
add ecx,eax					// ecx += (y-ymin - 1) * ROW_SIZE;
mov eax,[edi+$40] {x}
dec eax
sub eax,[edi+$44] {xmin}
mov ebx,[edi+$60] {Z}
sub ebx,[edi+$5c] {zmin}			// ebx = Z-zmin;
mul ebx
add ecx,eax					// ecx += (x-xmin - 1) * ebx;
sub eax,eax					// result = 0;
mov edx,ecx					// edx = ecx; // (1)
movzx esi,[edx]
imul esi,[esp+$24] {param_m11}
add eax,esi					// result += [edx] * param_m11; // [edx] == src(x-1,y-1,z)
add edx,ebx					// edx += Z-zmin; // next pixel
movzx esi,[edx]
imul esi,[esp+$20] {param_m12}
add eax,esi					// result += [edx] * param_m12; // [edx] == src(x  ,y-1,z)
add edx,ebx					// edx += Z-zmin; // next pixel
movzx esi,[edx]
imul esi,[esp+$1c] {param_m13}
add eax,esi					// result += [edx] * param_m13; // [edx] == src(x+1,y-1,z)
add ecx,[edi+$000045a0] {ROW_SIZE}		// ecx += ROW_SIZE;
mov edx,ecx					// edx = ecx; // next line
movzx esi,[edx]
imul esi,[esp+$18] {param_m21}
add eax,esi					// result += [edx] * param_m21; // [edx] == src(x-1,y  ,z)
add edx,ebx					// edx += Z-zmin; // next pixel
movzx esi,[edx]
imul esi,[esp+$14] {param_m22}
add eax,esi					// result += [edx] * param_m22; // [edx] == src(x  ,y  ,z)
add edx,ebx					// edx += Z-zmin; // next pixel
movzx esi,[edx]
imul esi,[esp+$10] {param_m23}
add eax,esi					// result += [edx] * param_m23; // [edx] == src(x+1,y  ,z)
add ecx,[edi+$000045a0] {ROW_SIZE}		// ecx += ROW_SIZE;
mov edx,ecx					// edx = ecx; // next line
movzx esi,[edx]
imul esi,[esp+$0c] {param_m31}
add eax,esi					// result += [edx] * param_m31; // [edx] == src(x-1,y+1,z)
add edx,ebx					// edx += Z-zmin; // next pixel
movzx esi,[edx]
imul esi,[esp+$08] {param_m32}
add eax,esi					// result += [edx] * param_m32; // [edx] == src(x  ,y+1,z)
add edx,ebx					// edx += Z-zmin; // next pixel
movzx esi,[edx]
imul esi,[esp+$04] {param_m33}
add eax,esi					// result += [edx] * param_m33; // [edx] == src(x+1,y+1,z)
cdq
idiv dword ptr [esp] {param_d}			// result /= param_d;
@div_zero:
add esp,$28 // = 10x pop
push eax					// return result;

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------

    @@__marker__end:
    db '<</MARKER>>';

    @@__print:
    lea eax,[@@__marker__begin]
    mov i,eax
    lea eax,[@@__marker__end]
    mov j,eax
  end;

  k := integer(j)-integer(i);
  WriteLn('Function: ' + funcname);
  WriteLn('Version:  ' + version);
  WriteLn('Params:   ' + IntToStr(paramnum));
  WriteLn('Compiled: ' + DateTimeToStr(FileDateToDateTime(FileAge(paramstr(0)))));
  WriteLn('Author:   ' + author);
  WriteLn('Length:   ' + inttostr(k));

  WriteLn('');
  WriteLn('Signature (FUNC):');
  for z := 1 to length(funcname) do
  begin
    Write(inttohex(ord(funcname[z]), 2) + ' ');
  end;
  for z := 8 downto length(funcname)+1 do
  begin
    Write('00 ');
  end;
  Write(inttohex(Lo(paramnum), 2)+' ');
  WriteLn(inttohex(Hi(paramnum), 2));

  WriteLn('');
  WriteLn('Prefix (OPER):');
  for z := 1 to length(funcname) do
  begin
    Write(inttohex(ord(funcname[z]), 2) + ' ');
  end;
  for z := 8 downto length(funcname)+1 do
  begin
    Write('00 ');
  end;
  Write(inttohex(Lo(k), 2)+' ');
  WriteLn(inttohex(Hi(k), 2));

  WriteLn('');
  WriteLn('Code (OPER):');
  for z := 0 to k-1 do
  begin
    Write(inttohex(ord(i^), 2));
    if (z = k-1) or ((z+1) mod linewidth = 0) then WriteLn('') else Write(' ');
    i := pointer(integer(i) + 1);
  end;

  if paramstr(1) <> 'nowait' then
  begin
    ReadLn(s);
  end;
end.
